
#IF .f.
**** REBUILD.PRG
* ------------------------------------------------------------------------------
*		Filename: REBUILD.prg
*     Please see documentation below.
*
*		Author : Froilan C. Yu Yap
*		
*     Note to maintenance programmer : 
*          This program actually consists of several source files gathered
*       into one.  A utility program, INTEG.prg automates the gathering 
*       process.
*
*		Created on March 22, 1993
*
* 							Copyright(C) 1993, Ng Khai Development Corp.
*
*		Modification log:
*
*
*
* ------------------------------------------------------------------------------

          Ŀ
                                 Rebuild                                      
                                                                               
              Bad files :        Report file :                                  
            Ŀ    Ŀ                
            CUSTOMER.DBF      < Choose... > REBUILD.REP                   
                                              
                               [X] Rebuild All                               
                               [ ] Scan only                                 
                               [ ] Halt on error                            
                 [ ] Overwrite damaged file                    
                                                                               
                                                  Rebuild                    
             Progress indicator Ŀ                                  
                                               < Cancel  >                   
                                              
          

   Rebuild attempts to reconstruct any damaged database files found in
directory it is run.

   Only DBF files defined in the STR file passed as parameter are checked
for possible damage.  DBF files found in the directory but not defined
in the STR file are not examined.

   During the course of scanning a damaged file, Rebuild regularly reports
any record/field it considers to contain invalid data to a text file.   
This reporting cannot be disabled.

Rebuild options :
[X] Rebuild All 
    Checking this box processes all files determined to be damaged.
    This is the default.  If unchecked, only the file marked with '' will
    be processed.
[ ] Scan only
    Disables rebuilding when checked, but still produces a report file.
[ ] Halt on error
    If checked, processing continues until a record containing bad data is
    encountered.  Otherwise, the whole file is processed.
[ ] Overwrite damaged file
    Damaged files are, by default, not overwritten but instead rebuilt to
    a file with the same base name as the damaged file but with a '.REB'
    extension.  Checking this rebuilds and overwrites the damaged file.

Rebuild supports the following data types : 
    Character, Numeric, Date, Logical, Memo
    
How Rebuild determines invalid data :

    1. For Character fields, any character with an ASCII value not within
       32 and 126 makes the entire field invalid.
    2. For Numeric fields, any character which is not in the character set
       for numerics makes the entire field invalid.  Specifically, TYPE()
       must evaluate to 'N' for the field to be considered valid.
    3. For Logical fields, any character other than 'T', 'F' or ' ' (space)
       makes the entire field invalid.
    4. For Memo and Date fields, any non-numeric character makes the entire 
       field invalid.

It must be noted that for a field of ANY type, a value of spaces (ASCII 32)
constitutes a (valid) null value corresponding to that of the field's type.
#ENDIF
*       ķ
*                                                                
*        03/22/94             REBUILD.SPR               16:02:27 
*                                                                
*       Ķ
*                                                                
*        Froilan C. Yu Yap                                       
*                                                                
*        Copyright (c) 1994 Ng Khai Development Corporation      
*        Hernan Cortes St., Banilad, Mandaue, Cebu               
*        City,     Zip                                           
*                                                                
*        Description:                                            
*        This program was automatically generated by GENSCRN.    
*                                                                
*       Ľ

* For comments or feedbacks, pls. contact Wilson Ng, EVP
* Ng Khai Development Corp.      73751.1012 @ Compuserve.com
* FAX (63-32)86241

PARAMETERS cstrfile 

*       ķ
*                                                                
*                 REBUILD/MS-DOS Setup Code - SECTION 1          
*                                                                
*       Ľ
*

#REGION 1

	cStrFile = upper(alltrim(cStrFile))
	if at('.', cStrFile) = 0
		cStrFile = cStrFile + '.STR'
	endif
	cStrFile = padr(cStrFile, 12)
	
	if !file(cStrFile)
		do alert with 'STR file not found.', 7, padl('OK', 8)
		return
	endif


#REGION 0
REGIONAL m.currarea, m.talkstat, m.compstat

IF SET("TALK") = "ON"
	SET TALK OFF
	m.talkstat = "ON"
ELSE
	m.talkstat = "OFF"
ENDIF
m.compstat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS

m.currarea = SELECT()


*       ķ
*                                                                
*                       MS-DOS Window definitions                
*                                                                
*       Ľ
*

IF NOT WEXIST("rebuild") ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.PJX" ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.SCX" ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.MNX" ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.PRG" ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.FRX" ;
	OR UPPER(WTITLE("REBUILD")) == "REBUILD.QPR"
	DEFINE WINDOW rebuild ;
		FROM INT((SROW()-16)/2),INT((SCOL()-55)/2) ;
		TO INT((SROW()-16)/2)+15,INT((SCOL()-55)/2)+54 ;
		TITLE "Rebuild" ;
		FLOAT ;
		CLOSE ;
		SHADOW ;
		MINIMIZE ;
		SYSTEM ;
		COLOR SCHEME 5
ENDIF


*       ķ
*                                                                
*                 REBUILD/MS-DOS Setup Code - SECTION 2          
*                                                                
*       Ľ
*

#REGION 1

*:: Parameters to main Rebuild routine ----- :
#Define REP_FILE 	aRParms[1]
#Define REB_ALL  	aRParms[2]
#Define SCAN_ONLY	aRParms[3]
#Define BRK_ONERR aRParms[4]
#Define OVERWRITE aRParms[5]

*:: Default extension of report file ----- :
#Define REP_EXT ".REP"

*:: Name of default report file ----- :
#Define DFAULTREP "REBUILD"+REP_EXT
private cSafety
	
	dimension aBadFiles[1]				&& List of bad tables
	dimension aRParms[5]					&& Parameters to rebuild routine.

	REP_FILE = DFAULTREP					&& Default report file name.
	REB_ALL = .t.

	aBadFiles[1] = ' '

	cSafety = set('SAFETY')
	set safety off

*       ķ
*                                                                
*                     REBUILD/MS-DOS Screen Layout               
*                                                                
*       Ľ
*

#REGION 1
IF WVISIBLE("rebuild")
	ACTIVATE WINDOW rebuild SAME
ELSE
	ACTIVATE WINDOW rebuild NOSHOW
ENDIF
@ 2,21 TO 4,51
@ 1,22 SAY "Report file :" ;
	SIZE 1,13, 0
@ 1,3 SAY "Bad files :" ;
	SIZE 1,11, 0
@ 11,1 TO 13,33
@ 11,2 SAY " Progress indicator " ;
	SIZE 1,20, 0
@ 2,1 GET m.cBadFile ;
 	PICTURE "@&N" ;
	FROM aBadFiles ;
	SIZE 7,16 ;
	DEFAULT 1 ;
	COLOR SCHEME 2
@ 3,23 GET m.cDir0 ;
	PICTURE "@*HN \<Choose..." ;
	SIZE 1,13,1 ;
	DEFAULT 1 ;
	VALID _qoj0ydrf4()
@ 3,37 GET REP_FILE ;
	SIZE 1,13 ;
	DEFAULT " " ;
	PICTURE "@K!" ;
	VALID _qoj0ydrjy()
@ 5,22 GET REB_ALL ;
	PICTURE "@*C Rebuild \<All" ;
	SIZE 1,15 ;
	DEFAULT 1
@ 6,22 GET SCAN_ONLY ;
	PICTURE "@*C \<Scan only" ;
	SIZE 1,13 ;
	DEFAULT 0 ;
	VALID _qoj0ydrp4()
@ 7,22 GET BRK_ONERR ;
	PICTURE "@*C \<Halt on error" ;
	SIZE 1,17 ;
	DEFAULT 0
@ 8,22 GET OVERWRITE ;
	PICTURE "@*C \<Overwrite damaged file" ;
	SIZE 1,26 ;
	DEFAULT 0
@ 10,38 GET m.nExec ;
	PICTURE "@*VN \!\<Rebuild;Cance\<l" ;
	SIZE 1,11,1 ;
	DEFAULT 1 ;
	VALID _qoj0ydrx3()

IF NOT WVISIBLE("rebuild")
	ACTIVATE WINDOW rebuild
ENDIF


*       ķ
*                                                                
*            MS-DOSREAD contains clauses from SCREEN rebuild     
*                                                                
*       Ľ
*

READ CYCLE ;
	WHEN _qoj0yds40() ;
	ACTIVATE _qoj0yds44() ;
	DEACTIVATE iif(wvisible('Rebuild'), .F., .T.) ;
	MODAL

RELEASE WINDOW rebuild
SELECT (m.currarea)


#REGION 0
IF m.talkstat = "ON"
	SET TALK ON
ENDIF
IF m.compstat = "ON"
	SET COMPATIBLE ON
ENDIF


*       ķ
*                                                                
*                      REBUILD/MS-DOS Cleanup Code               
*                                                                
*       Ľ
*

#REGION 1
close all

if cSafety = 'ON'
	set safety on
else
	set safety off
endif

*       ķ
*                                                                
*        _QOJ0YDRF4           m.cDir0 VALID                      
*                                                                
*        Function Origin:                                        
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD,     Record Number:    8   
*        Variable:            m.cDir0                            
*        Called By:           VALID Clause                       
*        Snippet Number:      1                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0ydrf4     &&  m.cDir0 VALID
#REGION 1
private cTemp
cTemp = sys(2014, getfile('REP','Choose a file :','Open',0))
if !empty(cTemp)
	REP_FILE = cTemp
endif
show get REP_FILE


*       ķ
*                                                                
*        _QOJ0YDRJY           REP_FILE VALID                     
*                                                                
*        Function Origin:                                        
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD,     Record Number:    9   
*        Variable:            REP_FILE                           
*        Called By:           VALID Clause                       
*        Snippet Number:      2                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0ydrjy     &&  REP_FILE VALID
#REGION 1
if empty(REP_FILE)
	REP_FILE = DFAULTREP
else
	if at('.', REP_FILE) = 0
		REP_FILE = alltrim(REP_FILE) + REP_EXT
	endif
endif
show get REP_FILE


*       ķ
*                                                                
*        _QOJ0YDRP4           SCAN_ONLY VALID                    
*                                                                
*        Function Origin:                                        
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD,     Record Number:   11   
*        Variable:            SCAN_ONLY                          
*        Called By:           VALID Clause                       
*        Snippet Number:      3                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0ydrp4     &&  SCAN_ONLY VALID
#REGION 1
private cPrompt
	
if SCAN_ONLY
	cPrompt = 'Scan \<All'

	show get OVERWRITE disable
	show get m.nExec, 1 prompt '\!Sca\<n'

	if alen(aBadFiles) = 1
		show get REB_ALL, 1 prompt cPrompt disable
	else
		show get REB_ALL, 1 prompt cPrompt enable
	endif
else
	cPrompt = 'Rebuild \<All'
	
	show get OVERWRITE enable
	show get m.nExec, 1 prompt '\!\<Rebuild'

	if alen(aBadFiles) = 1
		show get REB_ALL, 1 prompt cPrompt disable
	else
		show get REB_ALL, 1 prompt cPrompt enable
	endif
endif
return .T.

*       ķ
*                                                                
*        _QOJ0YDRX3           m.nExec VALID                      
*                                                                
*        Function Origin:                                        
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD,     Record Number:   14   
*        Variable:            m.nExec                            
*        Called By:           VALID Clause                       
*        Snippet Number:      4                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0ydrx3     &&  m.nExec VALID
#REGION 1
if m.nExec = 1
	if file(REP_FILE) and alert('Report file exists. Overwrite?', 7, '\!\<Yes;\?\<No') = 1
		erase (REP_FILE)
	endif
	do CreaTemp with aBadFiles, aRParms, m.cBadFile
	if REB_ALL
		private nI
	
		for nI = 1 to alen(aBadFiles)
			do FixFile with aBadFiles[nI]
		next
	else
		do FixFile with m.cBadFile
	endif
endif
clear read
return .T.

*       ķ
*                                                                
*        _QOJ0YDS40           Read Level When                    
*                                                                
*        Function Origin:                                        
*                                                                
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD                            
*        Called By:           READ Statement                     
*        Snippet Number:      5                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0yds40     && Read Level When
*
* When Code from screen: REBUILD
*
#REGION 1
	dimension aStrTables[1]


	if !GetFiles(cStrFile, @aStrTables)
		do alert with 'No table names found in STR file.', 7, padl('OK', 8)
		return .F.
	endif

	
	do GetBads with aBadFiles, aStrTables
	
	release aStrTables					&& No longer needed.
	
	if empty(aBadFiles[1])
		do alert with 'No defective database files found.', 7, padl('OK', 8)
		return .F.
	endif

	
	m.cBadFile = aBadFiles[1]			&& Bad file GET list var.
	show get m.cBadFile

	return .T.

*       ķ
*                                                                
*        _QOJ0YDS44           Read Level Activate                
*                                                                
*        Function Origin:                                        
*                                                                
*                                                                
*        From Platform:       MS-DOS                             
*        From Screen:         REBUILD                            
*        Called By:           READ Statement                     
*        Snippet Number:      6                                  
*                                                                
*       Ľ
*
FUNCTION _qoj0yds44     && Read Level Activate
*
* Activate Code from screen: REBUILD
*
#REGION 1

if alen(aBadFiles) = 1
	show get REB_ALL disable
endif

return 0
#Define REP_FILE 	aRParms[1]
#Define REB_ALL  	aRParms[2]
#Define SCAN_ONLY	aRParms[3]
#Define BRK_ONERR aRParms[4]
#Define OVERWRITE aRParms[5]

#Define REB_EXT   ".REB"

* ------------------------------------------------------------------------------
procedure FixFile		&& Main rebuild routine.
* ------------------------------------------------------------------------------
parameters cBadFile

private i, j
private nBadFile												&& File handles 
private cHeader, cRecord, cRawField						&& Buffers
private nHdrRecCnt, nHeadSize, nRecLen					&& Derived constants
private nFldCnt, aFld, nFPos, nRecno, bRecNoPrinted
private cRepFile, cGoodFile, cTextMDeli, nErrorType, cField, nRecCnt
private bBadField, bBadRecord, bDeleted
external array aRParms

	do ThermMsg with iif(SCAN_ONLY, 'Scanning ', 'Rebuilding ')+alltrim(m.cBadFile)+'.dbf'+' '	&& Thermometer message.
	
	*:: Open temporary copy of damaged dbf ----- :

	cGoodFile = alltrim(m.cBadFile) + REB_EXT
*	cGoodFile = left(cBadFile, at('.', cBadFile) - 1) + '.REB'
	use (cGoodFile) exclusive alias GOOD
	nFldCnt = afields(aFld)
	
	*:: Setup report file ----- :

	cTextMDeli = set('textmerge', 2)
	set textmerge delimiters to ''
	set textmerge to (REP_FILE) additive
	set textmerge on noshow

	*:: Open damaged dbf ----- :

	nBadFile = fopen(alltrim(m.cBadFile)+'.dbf', 2)
	if nBadFile = -1
		wait window 'Error in opening.' nowait
		return
	endif
	
	*:: Read the dbf header ----- :
	
	cHeader = fread(nBadFile, 32)
	
	*:: Get dbf info stored in header ----- :
	
	nFSize = FileSize(alltrim(m.cBadFile)+'.dbf')				&& File size.
	nHdrRecCnt = RecordCount(cHeader)		&& Record count.
	nHeadSize = HeadSize(cHeader)				&& Offset to data section. (Hdr size)
	nRecLen = RecLen(cHeader)					&& Record len (+delete flag).
	nRecCnt = (nFSize - header('GOOD') - 1) / recsize('GOOD') && Computed reccount.
	
	*:: Report header's condition ----- :
	
	do diagnose with cHeader, alltrim(m.cBadFile)+'.dbf', REP_FILE
	
	nRecno = 0
	=fseek(nBadFile, header('GOOD'))			&& Go to first data byte.
	
	*:: If no records, merely upate thermo ----- :

	if nRecCnt < 1
		do UpdTherm with 1, 1
	endif

	*:: Scan the file and validate field data ----- :
	
	bBadRecord = .F.
	do while !feof(nBadFile) and iif(BRK_ONERR, !bBadRecord, .T.)
		nRecno = nRecno + 1
		cRecord = fread(nBadFile, recsize('GOOD'))
		bDeleted = iif(left(cRecord,1) = '*', .T., .F.)
		cRecord = substr(cRecord, 2)
		if len(cRecord)+1 != recsize('GOOD')
			exit
		else
			do UpdTherm with nRecno, nRecCnt
		endif 
		nFPos = 1
		bRecNoPrinted = .F.
		bBadRecord = .F.

		for i = 1 to nFldCnt
			cRawField = substr(cRecord, nFPos, aFld[i,3])
			cField = cRawField
			bBadField = .F.
			do case
			case aFld[i,2] = 'C'
				cField = alltrim(cField)
				for j = 1 to len(cField)
					if asc(substr(cField,j,1)) < 32 or asc(substr(cField,j,1)) >= 126
						bBadField = .T.
						nErrorType = 2
						exit
					endif
				next
				store iif(bBadField, space(len(cRawField)), cRawField) to ('m.'+aFld[i,1])
			case aFld[i,2] = 'N' 
				if !empty(cField) and type(cField) != 'N'
					bBadField = .T.
					nErrorType = 1
				endif
				store iif(bBadField, 0, val(cRawField)) to ('m.'+aFld[i,1])
			case inlist(aFld[i,2], 'D', 'M')
				if !empty(cField) and type(cField) != 'N'
					bBadField = .T.
					nErrorType = 1
				endif
				if aFld[i,2] = 'D'
					store iif(bBadField, {}, StrToD(cRawField)) to ('m.'+aFld[i,1])
				endif
			case aFld[i,2] = 'L'
				if !inlist(cField, 'T', 'F', ' ')
					nErrorType = 1
					bBadField = .T.
				endif
				store iif(bBadField, .F., iif(cRawField='T', .T., .F.)) to ('m.'+aFld[i,1])
			endcase
			if bBadField
				bBadRecord = .T.
				if !bRecNoPrinted
					\* ---- Record no. nRecno
					bRecNoPrinted = .T.
				endif
				do case
				case nErrorType = 1
					\Invalid data in field aFld[i,1] : cRawField
				case nErrorType = 2
					\Suspicious character(s) in field aFld[i,1] : cRawField
				endcase
			endif
			
			nFPos = nFPos + aFld[i,3]
		next

		* Stop if made to stop on error ----- :

		if BRK_ONERR and bBadRecord
			wait window 'Bad record encountered.' nowait
			\
			\TEST TERMINATED DUE TO ERRONEOUS DATA IN RECORD.
			loop
		endif
		
		* Transfer to temp dbf ----- :

		if !SCAN_ONLY
			insert into (cGoodFile) from memvar
			if bDeleted or bBadRecord
				delete
			endif
		endif

	enddo

	set textmerge delimiters to cTextMDeli
	set textmerge to 
	set textmerge off
	
	close all

	if SCAN_ONLY 
		erase (cGoodFile)
	else
		if OVERWRITE
			erase (alltrim(m.cBadFile)+'.dbf')
			rename (cGoodFile) to (alltrim(m.cBadFile)+'.dbf')
		endif
	endif

****** FixFile ENDP

* ------------------------------------------------------------------------------
function RecordCount		&& Get record count according to dbf header.
* ------------------------------------------------------------------------------
parameters cHeader
private nHdrRecCnt, i

	nHdrRecCnt = 0
	for i = 0 to 3
		nHdrRecCnt = nHdrRecCnt + asc(substr(cHeader,5+i,1))*(256^i)
	next
	return round(nHdrRecCnt, 0)
***** RecordCount ENDP

* ------------------------------------------------------------------------------
function HeadSize		&& Get offset to first byte of data.
* ------------------------------------------------------------------------------
parameters cHeader
private nHeadSize, i

	nHeadSize = asc(substr(cHeader,9,1))
	nHeadSize = nHeadSize + asc(substr(cHeader,10,1)) * 256
	return nHeadSize
***** HeadSize ENDP

* ------------------------------------------------------------------------------
function RecLen    		&& Get record length (including delete flag)
* ------------------------------------------------------------------------------
parameters cHeader
private nRecLen, i

	nRecLen = asc(substr(cHeader,11,1))
	nRecLen = nRecLen + asc(substr(cHeader,12,1)) * 256
	return nRecLen
***** RecLen ENDP

* ------------------------------------------------------------------------------
function FileSize
* 	Returns a file's size.  Parameter must be the name of an existing file.
* 		Wildcards are not allowed.
* ------------------------------------------------------------------------------
parameters cFileName
private aDirInfo

	if adir(aDirInfo, cFileName) = 1
		return aDirInfo[1, 2]
	else
		return 0
	endif

***** FileSize ENDP	

* ------------------------------------------------------------------------------
procedure Diagnose
* ------------------------------------------------------------------------------
parameters cHeader, cBadFile, cRepFile
private x, cMode

	dimension x(4)

	*:: Build array for textmerge expression ----- :
	
	x(1) = iif(header('GOOD') = nHeadSize, 'O.K.', 'Failed' )
	x(2) = iif(recsize('GOOD') = nRecLen, 'O.K.', 'Failed' )
	x(3) = round(nRecCnt, 0)
	x(4) = iif(x(3) = nHdrRecCnt, 'O.K.', 'Failed' )
	cMode = iif(SCAN_ONLY, 'Scan Only; ', 'Scan & Rebuild; ') + ;
			  iif(BRK_ONERR, 'Process Until Error', 'Process Whole File') + ;
			  iif(SCAN_ONLY, '', iif(OVERWRITE, '; Overwrite Bad File', '; Do Not Overwrite Bad File'))
	cDestFileMsg = iif(!SCAN_ONLY and !OVERWRITE, ;
						'Damaged file rebuilt to ' + cGoodFile, '')
TEXT
--------------------------------------------------------------------------------
File : cBadFile

Time of test : time(), date()
Test mode    : cMode

Header size test  - x(1)
Record size test  - x(2)
Record count test - nHdrRecCnt record(s), computed at x(3) record(s) : x(4)

cDestFileMsg

ENDTEXT
	
***** Diagnose ENDP

* ------------------------------------------------------------------------------
function StrToD			&& Converts a YYYYMMDD date string to date.
* ------------------------------------------------------------------------------
parameters cDtStr
private dDate

	dDate = ctod(substr(cDtStr, 5, 2)+'/'+right(cDtStr, 2)+'/'+substr(cDtStr, 3, 2))
	return iif(empty(dtoc(dDate)), {}, dDate)
	
***** StrToD ENDP	

* ------------------------------------------------------------------------------
procedure GetBads		&& Get unreadable dbf files from current directory.
*  Filenames are stored in a one-dimensional array passed as parameter.
*  The array passed must be uninitialized.  A value of .F. for the first
*    element of the array after this procedure is called indicates 0 
*    bad files found.
* ------------------------------------------------------------------------------
parameters aBadTables, aStrTables
private i, aDbf, nFiles, bUseError, nBadFileCnt
private cOnError

	cOnError = on('ERROR')
	on error do TestIfBad with 'bUseError'		&& Detects 'Not a Database File.'

	nFiles = alen(aStrTables)						&& No. of files to check.
	
	nBadFileCnt	= 0									&& No. of bad files.
	do ThermMsg with 'Checking files '
	select 0
	for i = 1 to nFiles
		do UpdTherm with i, nFiles
		bUseError = .F.
		use (aStrTables[i])
		if bUseError
			nBadFileCnt = nBadFileCnt + 1
			dimension aBadTables[nBadFileCnt]
			aBadTables[nBadFileCnt] = aStrTables[i]
		endif
	next
	
	on error &cOnError
	
****** GetBads ENDP

* ------------------------------------------------------------------------------
function TestIfBad			
* Sets a flag if most recent USE resulted in a 'Not a database file' error.
* ------------------------------------------------------------------------------
parameters cFlagName					&& Name of flag as a character expression.

#Define NADF_CODE 15					&& Error code for 'Not a database file'.

	store iif(error()=NADF_CODE, .T., .F.) to (cFlagName)
***** TestIfBad ENDP

#Define REP_FILE 	aRParms[1]
#Define REB_ALL  	aRParms[2]
#Define SCAN_ONLY	aRParms[3]
#Define BRK_ONERR aRParms[4]
#Define OVERWRITE aRParms[5]

#Define REB_EXT   ".REB"

* ------------------------------------------------------------------------------
function CreaTemp		&& Creates temporary dbf's for each damaged file.
* ------------------------------------------------------------------------------
parameters aBadFiles, aRParms, m.cBadFile
external array aBadFiles, aRParms
private aTemp, nStrFound, i, cDbfFile

*	nStrFound = adir(aTemp, '*.str')

*	if nStrFound = 0
*		return 0
*	endif

*	create cursor STR (Line C(80))
*	append from (aTemp[1, 1]) sdf

	do ThermMsg with 'Creating temps ' 
	if REB_ALL
		for i = 1 to alen(aBadFiles)
			do UpdTherm with i, alen(aBadFiles)
			do CreaOne with aBadFiles[i], alltrim(aBadFiles[i]) + REB_EXT
*			cDbfFile = upper(left(aBadFiles[i], at('.', aBadFiles[i]) - 1))
*			do CreaOne with cDbfFile, cDbfFile + '.REB'
		next
	else
		do UpdTherm with 1, 1
		do CreaOne with m.cBadFile, alltrim(m.cBadFile) + REB_EXT
*		cDbfFile = upper(left(cBadFile, at('.', cBadFile) - 1))
*		do CreaOne with cDbfFile, cDbfFile + '.REB'
	endif
	
	close databases
	
*	return 1
***** CreaTemp ENDP

* ------------------------------------------------------------------------------
procedure CreaOne
* ------------------------------------------------------------------------------
parameters cDbfFile, cTempDbf
private all

	cDbfFile = alltrim(cDbfFile)
	cTempDbf = alltrim(cTempDbf)
	dimension structure(255, 4)					&& Max of 255 fields.
	dimension indextags(20, 2)						&& Max of 20 tags.
	m.fld_ctr = 1										&& Indexer for 'structure'
	m.ndx_ctr = 1										&& Indexer for 'indextags'

	select STR
	scan for at('FILE@', Line)	!= 0 ;
				and substr(Line, 10, 8) = padr(cDbfFile,8)

		m.fname_pos = at('FILE@', line)			&& DBF file name.
		if m.fname_pos != 0
			m.fld_ctr = 1
			m.ndx_ctr = 1
			
			m.dbf_file = alltrim(substr(line, 10, 8))
			
			do while .T.
				m.tag_pos = at('INDEX@', line)	&& Index tag.
				m.fld_pos = at('~', line)			&& Field definition.
				
				if m.tag_pos != 0
			      indextags(m.ndx_ctr, 1) = upper(alltrim(substr(line, 10, 10)))
			      indextags(m.ndx_ctr, 2) = upper(alltrim(substr(line, 21, 43)))
					m.ndx_ctr = m.ndx_ctr + 1
				endif
				if m.fld_pos != 0
	 				structure(m.fld_ctr, 1) = upper(left(alltrim(substr(line, 3, 11)),10))
	 				structure(m.fld_ctr, 2) = upper(alltrim(substr(line, 15, 5)))
					structure(m.fld_ctr, 3) = val(substr(line, 21, 5))
	 				structure(m.fld_ctr, 4) = val(substr(line, 27, 5))
					m.fld_ctr = m.fld_ctr + 1
				endif 
				
				if !eof()
					skip
				endif
				if at('FILE@', line) != 0 or eof()
					m.fields = m.fld_ctr - 1
					m.indexes = m.ndx_ctr - 1
				
					dimension structure(m.fields, 4)
					create table (cTempDbf) from array structure
					erase (upper(left(cTempDbf, at('.', cTempDbf) - 1)) + '.CDX')
					for m.ndx_ctr = 1 to m.indexes
						m.index_tag = indextags(m.ndx_ctr, 1)
						m.index_expr = indextags(m.ndx_ctr, 2)
						index on &index_expr tag (m.index_tag) additive
					next
					use in (cTempDbf)
					select STR
					
					dimension structure(255, 4)
					skip -1
					exit
				endif	
			enddo
		endif
	endscan
	
***** CreaOne ENDP

* ------------------------------------------------------------------------------
function GetFiles
* Creates the STR temp table, scans for table names and places them into an
*   array. Returns .T. if table name(s) are found, .F. otherwise.
* ------------------------------------------------------------------------------
parameters cStrFile, aFiles
private nFiles

	do ThermMsg with 'Setting up ... '

	create cursor STR (Line C(80))
	append from (cStrFile) sdf

	count for at('FILE@', Line) != 0 to nFilesInStr		&& For thermo
	nFiles = 0														&& No. of files found.
	do ThermMsg with 'Reading STR file ... '
	scan for at('FILE@', Line)	!= 0
		nFiles = nFiles + 1
		dimension aFiles[nFiles]
		aFiles[nFiles] = substr(Line, 10, 8)
		do UpdTherm with nFiles, nFilesInStr				&& Update progress meter.
	endscan
	if nFiles > 0
		return .T.
	else
		return .F.
	endif

***** GetFiles ENDP

* ------------------------------------------------------------------------------
procedure ThermMsg		&& Show message above thermometer.
* ------------------------------------------------------------------------------
parameters cMsg

	@wrows()-4, 2 say cMsg
***** ThermMsg ENDP	
#Define THERMWIDTH 30
#Define THERMCOL 2
#Define THERMROW (wrows()-2)

* THERWIDTH * 2  : 
#Define THERMSEGMENTS 60

* THERMCOL + THERMWIDTH : 
#Define THERMLASTCOL 32

* ------------------------------------------------------------------------------
procedure UpdTherm		&& Task progress thermometer.
* ------------------------------------------------------------------------------
parameters nPart, nWhole

	if type('_nPerRow') = 'U'
		public _nPerRow, _nPerCol

		_nPerRow = row()
		_nPerCol = col()
	endif
	if nWhole < THERMSEGMENTS
		private nBlocks

		@_nPerRow,_nPerCol say transform(nPart / nWhole * 100, '999%')
		nBlocks = nPart / nWhole * THERMWIDTH
		@THERMROW,THERMCOL say replicate('', int(nBlocks))
		if col() < THERMLASTCOL
			@ $, $ say iif(nBlocks - int(nBlocks) < 0.5, '', '')
		endif
	else
		private nFrac
		
		if type('_nThermCtr') = 'U'
			public _nThermCtr
			_nThermCtr = 0
		endif
		nFrac = nWhole / THERMSEGMENTS
		if nPart >= _nThermCtr * nFrac
			private nBlocks

			@_nPerRow,_nPerCol say transform(nPart / nWhole * 100, '999%')
			nBlocks = _nThermCtr / 2
			@THERMROW,THERMCOL say replicate('', int(nBlocks))
			if nBlocks - int(nBlocks) != 0
				@$,$ say ''
			endif
			_nThermCtr = _nThermCtr + 1
		endif
	endif
	if nPart >= nWhole
		=inkey(0.5, 'H')
		@THERMROW,THERMCOL clear to THERMROW,THERMCOL+THERMWIDTH 
		@_nPerRow,2 clear to _nPerRow, _nPerCol + 3
		if type('_nThermCtr') != 'U'
			release _nThermCtr
		endif
		release _nPerRow, _nPerCol
	endif
	
***** UpdTherm ENDP	
*:*********************************************************************
*:
*: Procedure file: C:\FOXPRO2\SNIPFMT\ALERT.PRG
*:
*:         System: SnipFmt
*:         Author: Walter J. Kennamer
*:      Copyright (c) 1991, Fox Holdings, Inc.
*:  Last modified: 05/05/91     15:49
*:
*:         Set by: SNIP.PRG                      
*:               : FMT            (procedure in SNIP.PRG)
*:
*:      Documented 05/16/91 at 16:07               FoxDoc  version 2.07
*:*********************************************************************
*!*****************************************************************
*!
*!      Procedure: ALERT
*!
*!*****************************************************************
procedure Alert
PARAMETERS strg, cscheme, buttons   

PRIVATE ALL

SET TALK OFF

in_cons = SET('CONSOLE')

numparams = 4
DIMENSION dflts[numparams,2]
dflts[1,1] = "STRG"
dflts[2,1] = "CSCHEME"
dflts[3,1] = "BUTTONS"
dflts[4,1] = "ACTION"
dflts[1,2] = ''
dflts[2,2] = 7
dflts[3,2] =''
dflts[4,2] = 0

action = 0

FOR i = 1 TO numparams
   IF PARAMETERS() < i
      vname = dflts[i,1]
      &vname = dflts[i,2]
   ENDIF
ENDFOR

m.numlines = OCCURS(';',strg) + 1          && number of message lines
IF !EMPTY(buttons)
   m.numbuts  = OCCURS(';',buttons) + 1    && number of buttons
ELSE
   m.numbuts = 0
ENDIF

DIMENSION alert_arry[numlines]

IF numbuts > 0
   DIMENSION but_arry[numbuts]
ELSE
   DIMENSION but_arry[1]
ENDIF

m.remain = m.strg
m.maxlen = 0
FOR i = 1 TO m.numlines
   IF AT(';',m.remain) > 0
      alert_arry[i] = SUBSTR(m.remain,1,AT(';',m.remain)-1)
      alert_arry[i] = CHRTRAN(alert_arry[i],';','')
      m.remain = SUBSTR(m.remain,AT(';',m.remain)+1)
   ELSE
      alert_arry[i] = m.remain
      m.remain = ''
   ENDIF
   IF LEN(alert_arry[i]) > SCOLS() - 6
      alert_arry[i] = SUBSTR(alert_arry[i],1,SCOLS()-6)
   ENDIF
   IF LEN(alert_arry[i]) > m.maxlen
      m.maxlen = LEN(alert_arry[i])
   ENDIF
ENDFOR

m.remain = m.buttons
m.maxbut = 0
FOR i = 1 TO m.numbuts
   IF AT(';',m.remain) > 0
      but_arry[i] = SUBSTR(m.remain,1,AT(';',m.remain)-1)
      but_arry[i] = CHRTRAN(but_arry[i],';','')
      m.remain = SUBSTR(m.remain,AT(';',m.remain)+1)
   ELSE
      but_arry[i] = m.remain
      m.remain = ''
   ENDIF
   IF LEN(but_arry[i]) > m.maxbut
      m.maxbut = LEN(but_arry[i])
   ENDIF
ENDFOR

IF !EMPTY(buttons)
   m.numlines = m.numlines + 2
ENDIF

m.butsize = m.numbuts * (m.maxbut + 3)    && chevrons + space
IF m.butsize > m.maxlen
   m.maxlen = m.butsize
ENDIF

m.top_row = INT( (SROWS() - 4 - m.numlines) / 2)
m.bot_row = m.top_row + 3 + m.numlines

m.top_col = INT((SCOLS() - m.maxlen - 6) / 2)
m.bot_col = m.top_col + m.maxlen + 6

DEFINE WINDOW alert FROM m.top_row,m.top_col TO m.bot_row,m.bot_col;
   SYSTEM FLOAT SHADOW COLOR SCHEME (cscheme)
ACTIVATE WINDOW alert

IF !EMPTY(buttons)
   FOR i = 1 TO m.numlines - 2
      @ i,3 SAY PADC(alert_arry[i],m.maxlen)
   ENDFOR
   m.butpos = 3 + (m.maxlen - m.butsize)/2
   @ m.numlines,m.butpos GET action FUNCTION '*HT' PICTURE buttons SIZE 1,m.maxbut+2,1
   READ CYCLE MODAL
ELSE
   FOR i = 1 TO m.numlines
      @ i,3 SAY PADC(alert_arry[i],m.maxlen)
   ENDFOR

   SET CONSOLE OFF
   =INKEY(0,'HM')
   SET CONSOLE ON
ENDIF
RELEASE WINDOW alert

IF in_cons = "OFF"
   SET CONSOLE OFF
ENDIF
RETURN action
*: EOF: ALERT.PRG
